
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.RenderingHints;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.geom.Ellipse2D;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.Timer;

public class ChangingElipseTimedAnimation extends JPanel implements ActionListener{
		
		private Ellipse2D.Float ellipse = new Ellipse2D.Float();
		private double esize = 20;
		private double maxSize = 200;
		private boolean initialize = true;
		private Timer timer;

		public ChangingElipseTimedAnimation() {
			setEllipseSize(20);
			timer = new Timer(20, this);
			timer.setInitialDelay(190);
			timer.start();
		}

		public void setEllipseSize(double size) {
			esize = size;
			ellipse.setFrame(0, 0, size, size);
		}

		public void step(int w, int h) {
			esize++;
			if (esize > w || esize > h) {
				setEllipseSize(1);
			} else {
				ellipse.setFrame(ellipse.getX(), ellipse.getY(), esize, esize);
			}
		}

		public void paint(Graphics g) {
			super.paintComponent(g);
			Graphics2D g2 = (Graphics2D) g;

			RenderingHints rh = new RenderingHints(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
			rh.put(RenderingHints.KEY_RENDERING, RenderingHints.VALUE_RENDER_QUALITY);
			g2.setRenderingHints(rh);

			g2.setColor(Color.BLUE);
			g2.fill(ellipse);
			g2.setColor(Color.BLACK);
			g2.draw(ellipse);
		}
		
		@Override
		public void actionPerformed(ActionEvent e) {
			Dimension size = getSize();
			this.step(size.width, size.height);
			repaint();
		}

		
		public static void main(String[] args) {
			JFrame frame = new JFrame("TimerBasedAnimation");
			frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
			frame.add(new ChangingElipseTimedAnimation());
			frame.setSize(350, 250);
			frame.setLocationRelativeTo(null);
			frame.setVisible(true);
		}

}
